class AngryCactus extends Enemy {
  float shooting_timer, max_shooting_timer;
  AngryCactus(float temp_x, float temp_y, Block[][] temp_blocks) {
    super(temp_x, temp_y, "angry cactus", "angry_cactus.png", 50, temp_blocks);
    attack = 5;
    health = 40;
    max_health = 40;
    speed = 3;
    attack_cooldown = 50;
    max_shooting_timer = 50;
  }
  
  void update(Player player) {
    if (shooting_timer == 0) {
      game.enemy_bullets.add(new EnemyBullet(super.location.x, super.location.y, 5, 500, "angry_cactus_bullet.png", 5, 0, true));
      shooting_timer = max_shooting_timer;
    } else {
      shooting_timer--;
    }
    super.update(player);
    if (super.is_dead) {
      float[] bullet_directions = new float[16];
      for (float i = 0; i < 360; i += 22.5) {
        bullet_directions[int(i/22.5)] = i;
      }
      for (float i : bullet_directions) {
        game.enemy_bullets.add(new EnemyBullet(super.location.x, super.location.y, 5, i, 500, "angry_cactus_bullet.png", 5, 0, true));
      }
    }
  }
}