class Button {
  PImage img, hovered_img;
  float x, y;
  boolean clicked;

  Button(float _x, float _y, String image_name) {
    x = _x;
    y = _y;
    img = texture_manager.get_texture(image_name);
    clicked = false;
  }
  
  Button(float _x, float _y, String image_name, String image_hovered_name) {
    x = _x;
    y = _y;
    img = texture_manager.get_texture(image_name);
    hovered_img = texture_manager.get_texture(image_hovered_name);
    clicked = false;
  }

  void display() {
    if (mouseOn() && mousePressed) {
      clicked = true;
    }
    
    if ((hovered_img != null) && mouseOn()) {
      image(hovered_img, x, y);
    } else {
      image(img, x, y);
    }
  }

  boolean mouseOn () {
    if ((mouseX > x - img.width/2) &&
        (mouseX < x + img.width/2) &&
        (mouseY > y - img.height/2) &&
        (mouseY < y + img.height/2)) {
      return true;
    } else {
      return false;
    }
  }
}