class Item {
  //the class for the items the player has in his inventory
  
  //global variables
  PImage inventory_img;
  String name, type;
  int mining_level, mining_speed, damage, use_cooldown;
  float size_increase;
  
  Item(PImage _inventory_img, String _type, String _name) {
    inventory_img = _inventory_img;
    type = _type;
    name = _name;
    mining_level = 1;
    mining_speed = 40;
    damage = 1;
    use_cooldown = 30;
    size_increase = 1;
  }
  
  //pick
  Item(PImage _inventory_img, String _name, int _mining_level, int _mining_speed, int _use_cooldown, float _size_increase) {
    inventory_img = _inventory_img;
    type = "picaxe";
    name = _name;
    mining_level = _mining_level;
    mining_speed = _mining_speed;
    damage = 1;
    use_cooldown = _use_cooldown;
    size_increase = _size_increase;
  }
  
  //sword
  Item(PImage _inventory_img, String _name, int _damage, int _use_cooldown, float _size_increase) {
    inventory_img = _inventory_img;
    type = "sword";
    name = _name;
    mining_level = 1;
    mining_speed = 40;
    damage = _damage;
    use_cooldown = _use_cooldown;
    size_increase = _size_increase;
  }
  
  //the item is 'used' by right clicking - at the momment, the only items that do anything when
  //used are the ones with the type 'block' (which places the block)
  boolean use(Player player) {
    if (type.equals("summoning")) {
      if (name.equals("cyclops summoning")) {
        //game.save_world();
        thread("save_world_file");
        for (int i = 0; i < blocks.length; i++) {
          for (int j = 0; j < blocks[i].length; j++) {
            if (blocks[i][j] != null) {
              blocks[i][j].collisionPossible = false;
            }
          }
        }
        //player.x = 300;
        game.load_world("cyclops", round((player.x-300)/20), 0);
        //while (true) {
        //  if (player.y_speed == 0) {
        game.enemies.add(new Cyclops(player.x, 7800, blocks));
        game.enemies.add(new CyclopsTower(player.x-650, 7680, blocks));
        game.enemies.add(new CyclopsTower(player.x+650, 7680, blocks));
        //    break;
        //  }
        //}
        //game.enemies.add(new Cyclops(player.x, player.y, blocks));
        return true;
      }
    }
    if (type.equals("block")) {
      boolean notOnBlock = true;
      for (int i = 0; i < blocks.length; i++) {
        for (int j = 0; j < blocks[i].length; j++) {
          if  (blocks[i][j] != null &&
               (player.x+mouseX-width/2 >= blocks[i][j].x - blocks[i][j].img.width/2) &&
               (player.x+mouseX-width/2 <= blocks[i][j].x + blocks[i][j].img.width/2) &&
               (player.y+mouseY-height/2 >= blocks[i][j].y - blocks[i][j].img.height/2) &&
               (player.y+mouseY-height/2 <= blocks[i][j].y + blocks[i][j].img.height/2))
          {
            notOnBlock = false;
          }
        }
      }
      if (notOnBlock) {
        int x_list_pos = round((player.x+mouseX-width/2)/20)+20;
        int y_list_pos = round((player.y+mouseY-height/2)/20);
        float x = round((player.x+mouseX-width/2)/20)*20;
        float y = round((player.y+mouseY-height/2)/20)*20;
        
        if ((dist(player.x, player.y, x, y) > 120) || (x_list_pos < 0 || x_list_pos > blocks.length-1 || y_list_pos < 0 || y_list_pos > blocks.length-1)) {
          return false;
        }
        
        if ((background_walls[x_list_pos][y_list_pos] == null) &&
            (!checkBlock(x_list_pos+1, y_list_pos)) && 
            (!checkBlock(x_list_pos-1, y_list_pos)) && 
            (!checkBlock(x_list_pos, y_list_pos+1)) && 
            (!checkBlock(x_list_pos, y_list_pos-1))) {
          return false;
        }
        
        
        if (name.equals("altar")) {
          blocks[x_list_pos][y_list_pos] = new Altar(x, y, x_list_pos, y_list_pos);
          updateSurroundingBlocks();
          return true;
        }
        else if (name.equals("dirt")) {
          blocks[x_list_pos][y_list_pos] = new DirtBlock(x, y, x_list_pos, y_list_pos);
          updateSurroundingBlocks();
          return true;
        }
        else if (name.equals("dried lava block")) {
          blocks[x_list_pos][y_list_pos] = new DriedLavaBlock(x, y, x_list_pos, y_list_pos);
          updateSurroundingBlocks();
          return true;
        }
        else if (name.equals("lava")) {
          blocks[x_list_pos][y_list_pos] = new LavaBlock(x, y, x_list_pos, y_list_pos);
          updateSurroundingBlocks();
          return true;
        }
        else if (name.equals("sand")) {
          blocks[x_list_pos][y_list_pos] = new SandBlock(x, y, x_list_pos, y_list_pos);
          updateSurroundingBlocks();
          return true;
        } else if (true) {
          blocks[x_list_pos][y_list_pos] = new CustomBlock(x_list_pos, y_list_pos, name);
          return true;
        }
      }
    }
    return false;
  }
  
  boolean customBlockExists(String block_name) {
    if (new CustomBlock(0, 0, block_name).mining_level != -1) {
      blocks[0][0] = null;
      return true;
    }
    return false;
  }
  
  boolean checkBlock(int x_pos, int y_pos) {
    try {
      return (x_pos > 0 && x_pos < blocks.length && y_pos > 0 && y_pos < blocks[0].length && (blocks[x_pos][y_pos] != null));
    } catch (ArrayIndexOutOfBoundsException e) {
      return false;
    }
  }
  
  void updateSurroundingBlocks() {
    //ArrayList<Light> lights = new ArrayList<Light>();
    //for (int i = max(0, round(round((player.x+mouseX-width/2)/20)*20/20)-5); i < min(round(round((player.x+mouseX-width/2)/20)*20/20)+5, blocks.length); i++) {
    //  for (int j = max(0, round(round((player.y+mouseY-height/2)/20)*20/20)-5); j < min(round(round((player.y+mouseY-height/2)/20)*20/20)+5, blocks[i].length); j++) {
    //    if (blocks[i][j] != null && blocks[i][j].light != null) {
    //      lights.add(blocks[i][j].light);
    //    }
    //  }
    //}
    //for (int i = max(0, round(player.x/20)-40); i < min(round(player.x/20)+40, blocks.length); i++) {
    //  int min_y_list_pos = 100000;
    //  for (int j = 0; j < blocks[i].length; j++) {
    //    if (blocks[i][j] != null) {
    //      min_y_list_pos = min(min_y_list_pos, j);
    //    }
    //  }
    //  if (i > 1 && i < blocks.length-1) {
    //    for (int j = 0; j < min_y_list_pos; j++) {
    //      if (blocks[i-1][j] != null) {
    //        lights.add(new Light(blocks[i-1][j].x, blocks[i-1][j].y, 100, color(255)));
    //      }
    //      if (blocks[i+1][j] != null) {
    //        lights.add(new Light(blocks[i+1][j].x, blocks[i+1][j].y, 100, color(255)));
    //      }
    //    }
    //  }
    //  lights.add(new Light(blocks[i][min_y_list_pos].x, blocks[i][min_y_list_pos].y, 100, color(255)));
    //}
    //for (int i = max(0, round(round((player.x+mouseX-width/2)/20)*20/20)-5); i < min(round(round((player.x+mouseX-width/2)/20)*20/20)+5, blocks.length); i++) {
    //  for (int j = max(0, round(round((player.y+mouseY-height/2)/20)*20/20)-5); j < min(round(round((player.y+mouseY-height/2)/20)*20/20)+5, blocks[i].length); j++) {
    //    if (blocks[i][j] != null) {
    //      blocks[i][j].update(lights);
    //    }
    //  }
    //}
  }
}