class LeafBlock extends Block {
  //a sub class of block. used instead of CustomBlock as it has an extra script.
  LeafBlock(float _x, float _y, int _x_list_pos, int _y_list_pos, String rotation) { //primary leaf block
    super(_x, _y, _x_list_pos, _y_list_pos, "leaf_block.png", "primary leaf block", 1, null);
    img = texture_manager.get_texture("primary_leaf_block_" + rotation + ".png");
    super.item = null;
    super.max_block_health = 1;
    super.block_health = 1;
  }
  
  LeafBlock(float _x, float _y, int _x_list_pos, int _y_list_pos) { //secondary leaf block
    super(_x, _y, _x_list_pos, _y_list_pos, "leaf_block.png", "secondary leaf block", 1, null);
    img = texture_manager.get_texture("leaf_block.png");
    super.item = null;
    super.max_block_health = 1;
    super.block_health = 1;
  }
  
  void update(ArrayList<Light> lights) {
    if (blocks[x_list_pos][y_list_pos].type.equals("secondary leaf block")) {
      //if there is no primary leaf block in the 4 adjacent places then the secondary leaf breaks.
      if (!checkBlock(x_list_pos, y_list_pos-1, "primary leaf block") &&
          !checkBlock(x_list_pos, y_list_pos+1, "primary leaf block") &&
          !checkBlock(x_list_pos-1, y_list_pos, "primary leaf block") &&
          !checkBlock(x_list_pos+1, y_list_pos, "primary leaf block")) {
        blocks[x_list_pos][y_list_pos] = null;
        return;
      }
    } else {
      //if there is no wood in the 4 adjacent places then the primary leaf breaks.
      if (!checkBlock(x_list_pos, y_list_pos-1, "wood block") &&
          !checkBlock(x_list_pos, y_list_pos+1, "wood block") &&
          !checkBlock(x_list_pos-1, y_list_pos, "wood block") &&
          !checkBlock(x_list_pos+1, y_list_pos, "wood block")) {
        blocks[x_list_pos][y_list_pos] = null;
        return;
      }
    }
    super.img = img.get();
    super.update(lights);
  }
  
  boolean checkBlock(int x_pos, int y_pos, String block_type) {
    return (x_pos > 0 && x_pos < blocks.length && y_pos > 0 && y_pos < blocks[0].length && (blocks[x_pos][y_pos] != null && blocks[x_pos][y_pos].type.equals(block_type)));
  }
}