class Phantom extends Enemy {
  boolean movingDown, movingUp;
  
  Phantom(float temp_x, float temp_y) {
    super(temp_x, temp_y, "phantom", "phantom_left.png", 70, null);
    attack = 3;
    health = 25;
    max_health = 25;
    speed = 5;
    attack_cooldown = 70;
  }
  
  void update(Player _player) {
    health_check();
    checkAttack(_player);
    move();
    if (player.x < location.x) {
      super.img = texture_manager.get_texture("phantom_left.png");
    } else {
      super.img = texture_manager.get_texture("phantom_right.png");
    }
    display();
  }
  
  void move() {
    if (player.x < location.x) {
      movingLeft = true;
      movingRight = false;
    } else {
      movingLeft = false;
      movingRight = true;
    }
    
    if (player.y < location.y) {
      movingDown = true;
      movingUp = false;
    } else {
      movingDown = false;
      movingUp = true;
    }
    
    if (movingLeft) {
      location.x -= speed;
    } else if (movingRight) {
      location.x += speed;
    }
    
    if (movingUp) {
      location.y += speed;
    } else if (movingDown) {
      location.y -= speed;
    }
  }
}