class Player {
  
  //global variables
  float x, y, speed;
  Block[][] blocks;
  
  float g_const, y_speed;
  boolean touching_ground;
  boolean facing_right;
  
  PImage img_right, img_left, original_img_right, original_img_left;
  boolean w_pressed, a_pressed, d_pressed;
  float step_cycle;
  float step_cycle_increase;
  //S, L1, L2, L1, S, R1, R2, R1
  String[] img_index_array_left = {"player_left.png", "player_left_left_step_1.png", "player_left_left_step_2.png", "player_left_left_step_1.png",
                                   "player_left.png", "player_left_right_step_1.png", "player_left_right_step_2.png", "player_left_right_step_1.png"};
  String[] img_index_array_right = {"player_right.png", "player_right_left_step_1.png", "player_right_left_step_2.png", "player_right_left_step_1.png",
                                    "player_right.png", "player_right_right_step_1.png", "player_right_right_step_2.png", "player_right_right_step_1.png"};
  
  PImage hotbar_frame, hotbar_frame_selected, recipe_frame;
  int hotbar_frame_selected_index;
  ItemStack[] inventory;
  ItemStack[] armor;
  ArrayList<RecipePointer> crafting_controller_recipe_pointers;
  boolean show_inventory;
  ItemStack held_item;
  CraftingController crafting_controller;
  
  int item_use_cooldown, max_item_use_cooldown;
  int attack, health, max_health;
  float armor_value;
  
  float playerBrightness;
  
  Player(float _x, float _y, Block[][] _blocks) {
    //global variables init
    x = _x;
    y = _y;
    speed = 5;
    original_img_right = texture_manager.get_texture("player_right.png");
    original_img_left = texture_manager.get_texture("player_left.png");
    img_right = original_img_right.get();
    img_left = original_img_left.get();
    facing_right = true;
    step_cycle = 0;
    step_cycle_increase = 0.5;
    
    blocks = _blocks;
    
    y_speed = 0;
    g_const = 1;
    touching_ground = false;
    
    hotbar_frame = texture_manager.get_texture("hotbar.png");
    hotbar_frame_selected = texture_manager.get_texture("hotbar_selected.png");
    recipe_frame = texture_manager.get_texture("recipe_frame.png");
    hotbar_frame_selected_index = 0;
    show_inventory = false;
    
    inventory = new ItemStack[210];
    armor = new ItemStack[4];
    crafting_controller = new CraftingController(inventory);
    crafting_controller_recipe_pointers = crafting_controller.returnRecipes();
    
    item_use_cooldown = 0;
    attack = 1;
    health = 20;
    max_health = 20;
    armor_value = 0;
    
    //Item bronze_pic = new Item(texture_manager.get_texture("steel_picaxe.png"), "steel picaxe", 200000000, 100, 30, 1.25);
    //addToStack(inventory, bronze_pic);
    //addToStack(inventory, new Item(texture_manager.get_texture("altar.png"), "block", "altar"));
    //Item wooden_sword = new Item(texture_manager.get_texture("wooden_sword.png"), "wooden sword", 100, 30, 1.25);
    //addToStack(inventory, wooden_sword);
    //for (int i = 0; i < 5000; i++) {
    //  addToStack(inventory, new Item(texture_manager.get_texture("lava_block.png"), "block", "lava"));
    //  addToStack(inventory, new Item(texture_manager.get_texture("torch.png"), "block", "torch"));
    //  addToStack(inventory, new Item(texture_manager.get_texture("stone_brick.png"), "block", "stone brick"));
      
    //  addToStack(inventory, new Item(texture_manager.get_texture("copper_ingot.png"), "item", "copper ingot"));
    //  addToStack(inventory, new Item(texture_manager.get_texture("tin_ingot.png"), "item", "tin ingot"));
    //  addToStack(inventory, new Item(texture_manager.get_texture("bronze_ingot.png"), "item", "bronze ingot"));
    //  addToStack(inventory, new Item(texture_manager.get_texture("iron_ingot.png"), "item", "iron ingot"));
    //  addToStack(inventory, new Item(texture_manager.get_texture("steel_ingot.png"), "item", "steel ingot"));
    //}
    //addToStack(inventory, new Item(texture_manager.get_texture("goblin.png"), "summoning", "cyclops summoning"));
    //addToStack(inventory, new Item(texture_manager.get_texture("iron_armor.png"), "armor", "iron armor"));
  }
  
  void update(ArrayList<Light> lights) {
    println("x: "+x+"\ty: "+y);
    try {
      max_item_use_cooldown = inventory[hotbar_frame_selected_index].items.get(0).use_cooldown;
    } catch (NullPointerException e) {
      max_item_use_cooldown = 30;
    }
    check_health();
    move();
    applyGravity();
    display(lights);
    popMatrix();
    checkBlockBreaking();
    //checkAttack();
    //loadPixels();
    //for (int i = 0; i < pixels.length; i++) {
    //  pixels[i] = lerpColor(color(pixels[i]), color(0, 50, 120), 0.8);
    //}
    //updatePixels();
    fill(0, 50, 120, 200);
    //rect(0, 0, width, height);
    drawHotbar();
    drawInventory();
  }
  
  //player controls
  void keyPressed() {
    if (key == 'a') {
      a_pressed = true;
      facing_right = false;
    }
    if (key == 'd') {
      d_pressed = true;
      facing_right = true;
    }
    if (key == 'w') {
      w_pressed = true;
    }
    
    if (key == '1' || key == '2' || key == '3' || key == '4' || key == '5' || key == '6' || key == '7' || key == '8' || key == '9' || key == '0') {
      hotbar_frame_selected_index = int(str(key))-1;
      if (hotbar_frame_selected_index == -1) {
        hotbar_frame_selected_index = 9;
      }
    }
    
    if (key == 'e') {
      show_inventory = !show_inventory;
    }
    
    if (key == 'q') {
      game.save_world();
    }
  }
  
  void keyReleased() {
    if (key == 'a') {
      a_pressed = false;
    }
    if (key == 'd') {
      d_pressed = false;
    }
    if (key == 'w') {
      w_pressed = false;
    }
  }
  
  void mousePressed() {
    //rect(player.x+mouseX-width/2, player.y+mouseY-height/2, 20, 20);
    if (mouseButton == RIGHT && !show_inventory) {
      if (inventory.length > hotbar_frame_selected_index) {
        if (inventory[hotbar_frame_selected_index] != null) {
          if (inventory[hotbar_frame_selected_index].items.get(0).use(player)) {
            inventory[hotbar_frame_selected_index].items.remove(0);
            if (inventory[hotbar_frame_selected_index].items.size() <= 0) {
              inventory[hotbar_frame_selected_index] = null;
            }
          }
        }
      }
    }
  }
  
  void mouseClicked() {
    if (show_inventory) {
      for (int i = 0; i < crafting_controller.returnRecipes().size(); i++) {
        if (mouseX < 30+i*40 + recipe_frame.width/2 &&
            mouseX > 30+i*40 - recipe_frame.width/2 &&
            mouseY < 550 + recipe_frame.height/2 &&
            mouseY > 550 - recipe_frame.height/2) {
            crafting_controller.executeRecipe(crafting_controller.returnRecipes().get(i));
            return;
        }
      }
    
      for (int i = 0; i < 10; i++) {
        if (mouseX < 30+i*50 + hotbar_frame.width/2 &&
            mouseX > 30+i*50 - hotbar_frame.width/2 &&
            mouseY < 30 + hotbar_frame.height/2 &&
            mouseY > 30 - hotbar_frame.height/2) {
            if (held_item == null) {
              held_item = inventory[i];
              inventory[i] = null;
            } else if (held_item != null && inventory[i] == null) {
              inventory[i] = held_item;
              held_item = null;
            } else if (held_item != null && inventory[i] != null) {
              ItemStack temp_item = held_item;
              held_item = inventory[i];
              inventory[i] = temp_item;
            }
            return;
        }
        
      }
      
      for (int i = 0; i < 20; i++) {
        for (int j = 1; j < 11; j++) {
          if (mouseX < 30+i*40 + hotbar_frame.width/2 &&
              mouseX > 30+i*40 - hotbar_frame.width/2 &&
              mouseY < 30+j*40 + hotbar_frame.height/2 &&
              mouseY > 30+j*40 - hotbar_frame.height/2) {
              if (held_item == null) {
                held_item = inventory[i+j*20-10];
                inventory[i+j*20-10] = null;
              } else if (held_item != null && inventory[i+j*20-10] == null) {
                inventory[i+j*20-10] = held_item;
                held_item = null;
              } else if (held_item != null && inventory[i+j*20-10] != null) {
                ItemStack temp_item = held_item;
                held_item = inventory[i+j*20-10];
                inventory[i+j*20-10] = temp_item;
              }
        }
      }
    }
    
    
    for (int i = 0; i < armor.length; i++) {
      if (held_item == null ||
          (i == 0 && held_item.items.get(0).type.equals("helmet")) || 
          (i == 1 && held_item.items.get(0).type.equals("armor")) || 
          (i == 2 && held_item.items.get(0).type.equals("boots")) || 
          (i == 3 && held_item.items.get(0).type.equals("accessory"))) {
        if (mouseX < width - 100 + hotbar_frame.width/2 &&
            mouseX > width - 100 - hotbar_frame.width/2 &&
            mouseY < 80+i*40 + hotbar_frame.height/2 &&
            mouseY > 80+i*40 - hotbar_frame.height/2) {
            if (held_item == null) {
              held_item = armor[i];
              armor[i] = null;
            } else if (held_item != null && armor[i] == null) {
              armor[i] = held_item;
              held_item = null;
            } else if (held_item != null && armor[i] != null) {
              ItemStack temp_item = held_item;
              held_item = armor[i];
              armor[i] = temp_item;
            }
            return;
        }
      }
    }
    
    //for (int i = 0; i < armor.length; i++) {
    //  if (
    //  image(hotbar_frame, width-100, 80+i*40);
    //  if (armor[i] != null) {
    //    image(inventory[inventory_counter].items.get(0).inventory_img, width-100, 80+i*40);
    //  }
    //}
    
    }
  }
  
  //adds an item to the inventory - first checks if a stack
  //of items of the same type already exists (in which case it
  //adds the item to the stack), or creates a new stack of items
  //of that type
  void addToStack(ItemStack[] inventory, Item item) {
    for (int i = 0; i < inventory.length; i++) {
      if (inventory[i] != null) {
        if (inventory[i].items.get(0).name.equals(item.name)) {
          inventory[i].items.add(item);
          return;
        }
      }
    }
    for (int i = 0; i < inventory.length; i++) {
      if (inventory[i] == null) {
        inventory[i] = new ItemStack(item, 1);
        return;
      }
    }
  }
  
  void move() {
    if (a_pressed) {
      x -= speed;
      boolean noCollision = true;
      for (int i = max(0, round(x/20)-40); i < min(round(x/20)+40, blocks.length); i++) {
        for (int j = max(0, round(y/20)-40); j < min(round(y/20)+40, blocks[i].length); j++) {
          if (blocks[i][j] != null && blocks[i][j].collisionPossible && detectBlockCollision(blocks[i][j])) {
            noCollision = false;
          }
        }
      }
      if (!noCollision) {
        x += speed;
        if (touching_ground) {
          y_speed = -7;
        }
      }
      step_cycle += step_cycle_increase;
      if (step_cycle >= 8) {
        step_cycle = 0;
      }
      original_img_left = texture_manager.get_texture(img_index_array_left[int(step_cycle)]);
    }
    if (d_pressed) {
      x += speed;
      boolean noCollision = true;
      for (int i = max(0, round(x/20)-40); i < min(round(x/20)+40, blocks.length); i++) {
        for (int j = max(0, round(y/20)-40); j < min(round(y/20)+40, blocks[i].length); j++) {
          if (blocks[i][j] != null && blocks[i][j].collisionPossible && detectBlockCollision(blocks[i][j])) {
            noCollision = false;
          }
        }
      }
      if (!noCollision) {
        x -= speed;
        if (touching_ground) {
          y_speed = -7;
        }
      }
      step_cycle += step_cycle_increase;
      if (step_cycle >= 8) {
        step_cycle = 0;
      }
      original_img_right = texture_manager.get_texture(img_index_array_right[int(step_cycle)]);
    }
    if (w_pressed && touching_ground) {
      y_speed = -15;
    }
  }
  
  void check_health() {
    if (health <= 0) {
      //println("You dun goofed.");
      //exit();
      x = 400;
      y = -height/2;
      health = 20;
    } else if (y > 10000) {
      x = 400;
      y = -height/2;
      health = 20;
    }
  }
  
  //displays the player and the item in his hand
  void display(ArrayList<Light> lights) {
    roughLighting(lights);
    if (facing_right) {
      image(img_right, x, y);
      if (inventory[hotbar_frame_selected_index] != null) {
        PImage holding_item_image = inventory[hotbar_frame_selected_index].items.get(0).inventory_img.get();
        holding_item_image = itemRoughLighting(lights, holding_item_image);
        pushMatrix();
        if (inventory[hotbar_frame_selected_index].items.get(0).type.equals("picaxe")) {
          holding_item_image.resize(round(inventory[hotbar_frame_selected_index].items.get(0).inventory_img.width*inventory[hotbar_frame_selected_index].items.get(0).size_increase), round(inventory[hotbar_frame_selected_index].items.get(0).inventory_img.height*inventory[hotbar_frame_selected_index].items.get(0).size_increase));
          translate(x+7.5, y+7.5);
          rotate(radians(map(max_item_use_cooldown-item_use_cooldown, 0, max_item_use_cooldown, 0, 30)*4));
          translate(12.5, -12.5);
        } else if (inventory[hotbar_frame_selected_index].items.get(0).type.equals("sword")) {
          holding_item_image.resize(round(inventory[hotbar_frame_selected_index].items.get(0).inventory_img.width*inventory[hotbar_frame_selected_index].items.get(0).size_increase), round(inventory[hotbar_frame_selected_index].items.get(0).inventory_img.height*inventory[hotbar_frame_selected_index].items.get(0).size_increase));
          if (item_use_cooldown>max_item_use_cooldown/3) {
            translate(x+7.5+map(max_item_use_cooldown-item_use_cooldown, 0, max_item_use_cooldown, 0, 30)/3, y+7.5);
            rotate(radians(map(max_item_use_cooldown-item_use_cooldown, 0, max_item_use_cooldown, 0, 30)*2.25));
            translate(12.5, -12.5);
          } else {
            translate(x+7.5+(map(item_use_cooldown, 0, max_item_use_cooldown, 0, 30))/3, y+7.5);
            rotate(radians(45));
            translate(12.5, -12.5);
          }
        } else {
          holding_item_image.resize(10, 10);
          translate(x+10, y+10);
          rotate(radians(80));
        }
        image(holding_item_image, 0, 0);
        popMatrix();
        if (armor[1] != null) {
          image(armor[1].items.get(0).inventory_img, x, y);
          println("!");
        }
      }
    } else {
      image(img_left, x, y);
      if (inventory[hotbar_frame_selected_index] != null) {
        PImage holding_item_image = inventory[hotbar_frame_selected_index].items.get(0).inventory_img.get();
        holding_item_image = itemRoughLighting(lights, holding_item_image);
        pushMatrix();
        if (inventory[hotbar_frame_selected_index].items.get(0).type.equals("picaxe")) {
          holding_item_image.resize(25, 25);
          translate(x-7.5, y+7.5);
          rotate(radians(map(max_item_use_cooldown-item_use_cooldown, 0, max_item_use_cooldown, 0, 30)*-4));
          translate(-12.5, -12.5);
          rotate(radians(-90));
        } else if (inventory[hotbar_frame_selected_index].items.get(0).type.equals("sword")) {
          holding_item_image.resize(25, 25);
          if (item_use_cooldown>max_item_use_cooldown/3) {
            translate(x-7.5-(map(max_item_use_cooldown-item_use_cooldown, 0, max_item_use_cooldown, 0, 30))/3, y+7.5);
            rotate(radians((map(max_item_use_cooldown-item_use_cooldown, 0, max_item_use_cooldown, 0, 30))*-2.25));
            translate(-12.5, -12.5);
            rotate(radians(-90));
          } else {
            translate(x-7.5-map(item_use_cooldown, 0, max_item_use_cooldown, 0, 30)/3, y+7.5);
            rotate(radians(-45));
            translate(-12.5, -12.5);
            rotate(radians(-90));
          }
        } else {
          holding_item_image.resize(10, 10);
          translate(x-10, y+10);
          rotate(radians(-80));
        }
        image(holding_item_image, 0, 0);
        popMatrix();
      }
    }
  }
  
  void roughLighting(ArrayList<Light> lights) {
    playerBrightness = 0;
    PImage img;
    if (facing_right) {
      img = original_img_right.get();
    } else {
      img = original_img_left.get();
    }
    img.loadPixels();
    for (Light light : lights) {
      float dist_to_light = dist(x, y, light.x, light.y);
      float current_light_intensity = constrain(light.intensity/pow(dist_to_light/50, 2), 0, light.intensity);
      for (int i = 0; i < img.width*img.height; i++) {
        int r = round(red(img.pixels[i]));
        int g = round(green(img.pixels[i]));
        int b = round(blue(img.pixels[i]));
        if (light.lightColor != color(255)) {
          if (current_light_intensity <= 1) {
            r = round((red(img.pixels[i]) + red(light.lightColor)*current_light_intensity)/(1+current_light_intensity));
            g = round((green(img.pixels[i]) + green(light.lightColor)*current_light_intensity)/(1+current_light_intensity));
            b = round((blue(img.pixels[i]) + blue(light.lightColor)*current_light_intensity)/(1+current_light_intensity));
          } else {
            r = round((red(img.pixels[i]) + red(light.lightColor))/2);
            g = round((green(img.pixels[i]) + green(light.lightColor))/2);
            b = round((blue(img.pixels[i]) + blue(light.lightColor))/2);
          }
          }
        img.pixels[i] = color(round(r), round(g), round(b), alpha(img.pixels[i]));
      }
      float tempBrightness = current_light_intensity/10;
      playerBrightness = max(playerBrightness, tempBrightness);
    }
    playerBrightness = constrain(playerBrightness, 0, 1);
    for (int i = 0; i < img.width*img.height; i++) {
      img.pixels[i] = color(red(img.pixels[i])*playerBrightness, green(img.pixels[i])*playerBrightness, blue(img.pixels[i])*playerBrightness, alpha(img.pixels[i]));
    }
    img.updatePixels();
    if (facing_right) {
      img_right = img.get();
    } else {
      img_left = img.get();
    }
  }
  
  PImage itemRoughLighting(ArrayList<Light> lights, PImage img) {
    playerBrightness = 0;
    img.loadPixels();
    for (Light light : lights) {
      float dist_to_light = dist(x, y, light.x, light.y);
      float current_light_intensity = constrain(light.intensity/pow(dist_to_light/50, 2), 0, light.intensity);
      for (int i = 0; i < img.width*img.height; i++) {
        int r = round(red(img.pixels[i]));
        int g = round(green(img.pixels[i]));
        int b = round(blue(img.pixels[i]));
        if (light.lightColor != color(255)) {
          if (current_light_intensity <= 1) {
            r = round((red(img.pixels[i]) + red(light.lightColor)*current_light_intensity)/(1+current_light_intensity));
            g = round((green(img.pixels[i]) + green(light.lightColor)*current_light_intensity)/(1+current_light_intensity));
            b = round((blue(img.pixels[i]) + blue(light.lightColor)*current_light_intensity)/(1+current_light_intensity));
          } else {
            r = round((red(img.pixels[i]) + red(light.lightColor))/2);
            g = round((green(img.pixels[i]) + green(light.lightColor))/2);
            b = round((blue(img.pixels[i]) + blue(light.lightColor))/2);
          }
          }
        img.pixels[i] = color(round(r), round(g), round(b), alpha(img.pixels[i]));
      }
      float tempBrightness = current_light_intensity/10;
      playerBrightness = max(playerBrightness, tempBrightness);
    }
    playerBrightness = constrain(playerBrightness, 0, 1);
    for (int i = 0; i < img.width*img.height; i++) {
      img.pixels[i] = color(red(img.pixels[i])*playerBrightness, green(img.pixels[i])*playerBrightness, blue(img.pixels[i])*playerBrightness, alpha(img.pixels[i]));
    }
    img.updatePixels();
    return img;
  }
  
  void applyGravity() {
    y_speed = constrain(100000000, 200, y_speed+g_const);
    y += y_speed;
    boolean noCollision = true;
    touching_ground = false;
    for (int i = max(0, round(x/20)-40); i < min(round(x/20)+40, blocks.length); i++) {
      for (int j = max(0, round(y/20)-40); j < min(round(y/20)+40, blocks[i].length); j++) {
        if (blocks[i][j] != null && blocks[i][j].collisionPossible && detectBlockCollision(blocks[i][j])) {
          noCollision = false;
        }
      }
    }
    if (!noCollision) {
      y -= y_speed;
      y_speed = 0;
      touching_ground = true;
    }
  }
  
  boolean detectBlockCollision (Block block) {
    if  ((x + img_right.width/2 >= block.x - block.img.width/2) &&
         (x - img_right.width/2 <= block.x + block.img.width/2) &&
         (y + img_right.height/2 >= block.y - block.img.height/2) &&
         (y - img_right.height/2 <= block.y + block.img.height/2))
    {
          return true;
    }
    return false;
  }
  
  boolean detectCollision (PImage img1, float x1, float y1, PImage img2, float x2, float y2) {
    if  ((x1 + img1.width/2 >= x2 - img2.width/2) &&
         (x1 - img1.width/2 <= x2 + img2.width/2) &&
         (y1 + img1.height/2 >= y2 - img2.height/2) &&
         (y1 - img1.height/2 <= y2 + img2.height/2))
    {
          return true;
    }
    return false;
  }
  
  //checks if the player is hitting a block
  void checkBlockBreaking() {
    if (mousePressed && mouseButton == LEFT) {
      if (item_use_cooldown == 0) {
        item_use_cooldown = max_item_use_cooldown;
        if (!show_inventory) {
          for (int i = 0; i < blocks.length; i++) {
            for (int j = 0; j < blocks[i].length; j++) {
              if  (blocks[i][j] != null &&
                   (player.x+mouseX-width/2 >= blocks[i][j].x - blocks[i][j].img.width/2) &&
                   (player.x+mouseX-width/2 <= blocks[i][j].x + blocks[i][j].img.width/2) &&
                   (player.y+mouseY-height/2 >= blocks[i][j].y - blocks[i][j].img.height/2) &&
                   (player.y+mouseY-height/2 <= blocks[i][j].y + blocks[i][j].img.height/2) &&
                   (dist(player.x, player.y, blocks[i][j].x, blocks[i][j].y) < 120))
              {
                int player_mining_level, player_mining_speed;
                if (inventory[hotbar_frame_selected_index] == null) {
                  player_mining_level = 1;
                  player_mining_speed = 40;
                } else {
                  player_mining_level = inventory[hotbar_frame_selected_index].items.get(0).mining_level;
                  player_mining_speed = inventory[hotbar_frame_selected_index].items.get(0).mining_speed;
                }
                if (blocks[i][j].mining_level <= player_mining_level) {
                  blocks[i][j].block_health -= player_mining_speed;
                  if (blocks[i][j].block_health <= 0) {
                    if (blocks[i][j].item != null) {
                      addToStack(inventory, blocks[i][j].item);
                    }
                    blocks[i][j].kill();
                    //blocks[i][j] = null;
                  }
                }
              }
            }
          }
          
          for (int i = 0; i < game.enemies.size(); i++) {
            if (inventory[hotbar_frame_selected_index] != null) {
              //println("click" + dist(0, 0, inventory[hotbar_frame_selected_index].items.get(0).inventory_img.width*inventory[hotbar_frame_selected_index].items.get(0).size_increase, inventory[hotbar_frame_selected_index].items.get(0).inventory_img.height*inventory[hotbar_frame_selected_index].items.get(0).size_increase));
              if ((facing_right && dist(x+20, y-5, game.enemies.get(i).location.x, game.enemies.get(i).location.y) < dist(0, 0, inventory[hotbar_frame_selected_index].items.get(0).inventory_img.width*inventory[hotbar_frame_selected_index].items.get(0).size_increase, inventory[hotbar_frame_selected_index].items.get(0).inventory_img.height*inventory[hotbar_frame_selected_index].items.get(0).size_increase) + dist(0, 0, game.enemies.get(i).img.width/2, game.enemies.get(i).img.height/2)) ||
                  (!facing_right && dist(x-20, y-5, game.enemies.get(i).location.x, game.enemies.get(i).location.y) < dist(0, 0, inventory[hotbar_frame_selected_index].items.get(0).inventory_img.width*inventory[hotbar_frame_selected_index].items.get(0).size_increase, inventory[hotbar_frame_selected_index].items.get(0).inventory_img.height*inventory[hotbar_frame_selected_index].items.get(0).size_increase) + dist(0, 0, game.enemies.get(i).img.width/2, game.enemies.get(i).img.height/2))) {
                game.enemies.get(i).health -= inventory[hotbar_frame_selected_index].items.get(0).damage;
                game.enemies.get(i).knockback_on = true;
                PVector temp = new PVector(game.enemies.get(i).location.x - x, game.enemies.get(i).location.y - y - img_right.height/2);
                temp.normalize();
                temp.mult(10);
                game.enemies.get(i).knockback = temp;
                println("hit " + inventory[hotbar_frame_selected_index].items.get(0).damage);
              }
            } else {
              if ((facing_right && dist(x+20, y-5, game.enemies.get(i).location.x, game.enemies.get(i).location.y) < 50) ||
                  (!facing_right && dist(x-20, y-5, game.enemies.get(i).location.x, game.enemies.get(i).location.y) < 50)) {
                game.enemies.get(i).health -= 1;
                game.enemies.get(i).knockback_on = true;
                PVector temp = new PVector(game.enemies.get(i).location.x - x, game.enemies.get(i).location.y - y - img_right.height/2);
                temp.normalize();
                temp.mult(10);
                game.enemies.get(i).knockback = temp;
              }
            }
          }
          
        }
      } else {
        item_use_cooldown--;
      }
    } else {
      item_use_cooldown = max_item_use_cooldown;
    }
  }
  
  //draws the hotbar
  void drawHotbar() {
    for (int i = 0; i < 10; i++) {
      if (i == hotbar_frame_selected_index) {
        image(hotbar_frame_selected, 30+i*50, 30);
      } else {
        image(hotbar_frame, 30+i*50, 30);
      }
      if (inventory.length > i) {
        if (inventory[i] != null) {
          image(inventory[i].items.get(0).inventory_img, 30+i*50, 30);
          if (inventory[i].items.size() > 0) {
            fill(0);
            text("x"+str(inventory[i].items.size()), 30+hotbar_frame.width/2+i*50, 40);
          }
        }
      }
    }
  }
  
  //draws the inventory if needed
  void drawInventory() {
    if (show_inventory) {
      int inventory_counter = 10;
      for (int j = 1; j < 11; j++) {
        for (int i = 0; i < 20; i++) {
          image(hotbar_frame, 30+i*40, 30+j*40);
            if (inventory[inventory_counter] != null) {
              image(inventory[inventory_counter].items.get(0).inventory_img, 30+i*40, 30+j*40);
              if (inventory[inventory_counter].items.size() >= 2) {
                fill(0);
                text("x"+str(inventory[inventory_counter].items.size()), 30+hotbar_frame.width/2+i*40, 40+j*40);
              }
            }
          inventory_counter++;
        }
      }
      
      for (int i = 0; i < armor.length; i++) {
        image(hotbar_frame, width-100, 80+i*40);
        if (armor[i] != null) {
          image(armor[i].items.get(0).inventory_img, width-100, 80+i*40);
        }
      }
      //boolean inventory_update_needed = false;
      //for (int i = 0; i < inventory.length; i++) {
      //  //if (!(inventory[i] == null && crafting_controller.previous_inventory[i] == null || (!inventory[i].equals(crafting_controller.previous_inventory[i])))) {
      //  if  ((inventory[i] == null && crafting_controller.previous_inventory[i] != null) ||
      //      (inventory[i] != null && crafting_controller.previous_inventory[i] == null) ||
      //      ((inventory[i] != null && crafting_controller.previous_inventory[i] != null) && !(inventory[i].equals(crafting_controller.previous_inventory[i])))) {
      //    inventory_update_needed = true;
      //    break;
      //  }
      //}
      //if (inventory_update_needed) {
      //  thread("updatePlayerInventory");
      //  println(millis());
      //}
      updatePlayerInventory();
      for (int i = 0; i < crafting_controller_recipe_pointers.size(); i++) {
        image(recipe_frame, 30+i*40, 550);
        image(crafting_controller_recipe_pointers.get(i).img, 30+i*40, 550);
      }
      
      if (held_item != null) {
        //image(held_item.items.get(0).inventory_img, mouseX-held_item.items.get(0).inventory_img.width/2, mouseY-held_item.items.get(0).inventory_img.height/2);
        image(held_item.items.get(0).inventory_img, mouseX, mouseY);
        text("x"+str(held_item.items.size()), hotbar_frame.width/2+mouseX, 10+mouseY);
      } else {
        textAlign(LEFT, TOP);
        
          //for (int i = 0; i < crafting_controller.returnRecipes().size(); i++) {
          //  if (mouseX < 30+i*40 + recipe_frame.width/2 &&
          //      mouseX > 30+i*40 - recipe_frame.width/2 &&
          //      mouseY < 550 + recipe_frame.height/2 &&
          //      mouseY > 550 - recipe_frame.height/2) {
          //      crafting_controller.executeRecipe(crafting_controller.returnRecipes().get(i));
          //      return;
          //  }
          //}
        
          for (int i = 0; i < 10; i++) {
            if (mouseX < 30+i*50 + hotbar_frame.width/2 &&
                mouseX > 30+i*50 - hotbar_frame.width/2 &&
                mouseY < 30 + hotbar_frame.height/2 &&
                mouseY > 30 - hotbar_frame.height/2) {
                  if (inventory[i] != null) {
                    text(inventory[i].items.get(0).name, mouseX, mouseY);
                  }
            }
            
          }
          
          for (int i = 0; i < 20; i++) {
            for (int j = 1; j < 11; j++) {
              if (mouseX < 30+i*40 + hotbar_frame.width/2 &&
                  mouseX > 30+i*40 - hotbar_frame.width/2 &&
                  mouseY < 30+j*40 + hotbar_frame.height/2 &&
                  mouseY > 30+j*40 - hotbar_frame.height/2) {
                    if (inventory[i+j*20-10] != null) {
                      text(inventory[i+j*20-10].items.get(0).name, mouseX, mouseY);
                    }
            }
          }
        }
        
        
        for (int i = 0; i < armor.length; i++) {
            if (mouseX < width - 100 + hotbar_frame.width/2 &&
                mouseX > width - 100 - hotbar_frame.width/2 &&
                mouseY < 80+i*40 + hotbar_frame.height/2 &&
                mouseY > 80+i*40 - hotbar_frame.height/2) {
                  if (armor[i] != null) {
                    text(armor[i].items.get(0).name, mouseX, mouseY);
                  }
            }
        }
            
        textAlign(CENTER);
      }
      
    }
  }
  
  void updateInventory() {
    for (int i = 0; i < inventory.length; i++) {
      crafting_controller.previous_inventory[i] = inventory[i];
    }
    crafting_controller_recipe_pointers = crafting_controller.returnRecipes();
  }
  
  void damage(float enemy_attack) {
    health -= constrain(enemy_attack-armor_value, 1, health);
  }
}